function [ H,S,R,Q,IW,B,LW ] = ELM( P,T,N,TF,TYPE,C )
%룺
% P:   R*Q
% T S*Q
% N: Ԫ ĬΪQ
% TFݺ 'sig' 'sin' 'hardlim'
% TYPE: ع飨Ĭϻ0ࣨ1

%
%IW: Ȩؾ N*R
% B: ƫ N*1
% LW:  N*S
if nargin < 2
    error('Not enough input arguments');
end
if nargin < 3
    N=size(P, 2);
end
if nargin < 4
    TF='sig';
end
if nargin < 5
    TYPE='0';
end
if size(P,2) ~= size(T,2)
    error('P and T column must be same');
end
[R,Q] = size(P);
if TYPE ==1
    T= ind2vec(T);
end
[S,Q] = size(T);
IW = rand(N,R) * 2 -1;   % Ȩؾ
B= rand(N,1);   %ƫþ
BiasMatrix = repmat (B,1,Q);
%% H
tempH = IW * P +BiasMatrix;
switch TF
    case 'sig'
        H= 1 ./ (1 + exp(-tempH));
    case 'sin'
        H= sin(tempH);
    case 'hardlim'
        H= hardlim(tempH);
         case 'radbas'
        %%%%%%%% Radial basis function
        H = radbas(tempH);
end
% LW= pinv(H') * T';
LW=inv(eye(size(H,1))/C+H * H') * H * T'; 

end

